const nsIFilePicker = Components.interfaces.nsIFilePicker;

// Associative array by participant ID
var resultData = new Object();

// 2-deep Associative array representing the co-occurence
// of category members.
var resultGrid = new Object();
var resultCorrelations = new Object();
var sampleSize;
var numCats;
var groups = new Array();

var toBeCategorized = new Object();

function startupAnalysis() {
	loadDataFiles();
}

function loadDataFileNames() {
	resultData = new Object();
	resultGrid = new Object();
	var du=new DirUtils(); 
	var tempNode, tempCatName;
	var tempFile, tempFileName, tempLabel;
	var listbox = 		document.getElementById("participant-list");
	var dataPath = du.getChromeDir() + fileSeparator + 'uzcardsort' + fileSeparator + 'content' + fileSeparator + 'data' + fileSeparator + projectInfo.name + fileSeparator ;
	var dataFolder = new Dir(dataPath);
	dataFiles =dataFolder.readDir();	
	
	for(var i=0;i<dataFiles.length;i++) {
		tempFile = dataFiles[i];
		tempFileName = tempFile.path;
		tempLabel = tempFileName.replace('.xml', '');
		tempNode = document.createElement("listitem");
		tempNode.setAttribute("label", listLast(tempLabel, fileSeparator));
		listbox.appendChild(tempNode);
	}
}

function loadDataFiles() {
	resultData = new Array(1);
	var du=new DirUtils(); 
	var tempNode, tempCatName;
	var tempFile, tempFileName, tempLabel;
	var listbox = 		document.getElementById("participant-list");
	deleteAllChilds(listbox);
	var dataPath = du.getChromeDir() + fileSeparator + 'uzcardsort' + fileSeparator + 'content' + fileSeparator + 'data' + fileSeparator + projectInfo.name + fileSeparator ;
	var dataFolder = new Dir(dataPath);
	dataFiles =dataFolder.readDir();	
	sampleSize = parseInt(dataFiles.length);
	for(var i=0;i<dataFiles.length;i++) {
		tempFile = dataFiles[i];
		tempFileName = tempFile.path;
		tempLabel = tempFileName.replace('.xml', '');
		tempNode = document.createElement("listitem");
		tempNode.setAttribute("label", listLast(tempLabel, fileSeparator));
		listbox.appendChild(tempNode);
		loadDataFile(tempFile.path);
		buildResultsGrid();
	}
}

function loadDataFile(dataPath) {
	dump("Pulling data for " + dataPath + "\n");
	var tempName, xmlData, categoryNodes, tempCat, tempLabel;
	
	var dataID = listLast(dataPath, fileSeparator);
	var categoryObject;
	dataID = dataID.replace('.xml', '');
	resultData[dataID]= new Object();
	dataFile = new File(dataPath);
	dataFile.open("r");
	xmlData = dataFile.read();
	dataFile.close();
	dump("Data file read, storing to " + dataID + "\n");
	resultDOM = new DOMParser().parseFromString(xmlData, "text/xml");
	categoryNodes = resultDOM.getElementsByTagName("category");
	dump("Found classifications for " + categoryNodes.length + "\n");
	for(var i=0;i<categoryNodes.length;i++) {
		dump("Category holder " + i + "\n");
		tempCat = categoryNodes.item(i);
		tempName = tempCat.getAttribute("label");
		if(!tempName.length) tempName = "cat" + i;
		dump("Adding key of " + tempName + "\n");
		resultData[dataID][tempName] =new Object();
		categoryObject = resultData[dataID][tempName];
		categoryObject.values = '';
		
		for(var j=0; j<tempCat.childNodes.length;j++) {
			dump("Classification " + j + "\n");
			// Only add a comma for non-first items
			tempLabel = tempCat.childNodes.item(j).getAttribute("label");
			if(categoryObject.values.length) categoryObject.values = categoryObject.values + ',';
			categoryObject.values = categoryObject.values + tempLabel;
		}
		dump(categoryObject.values + " is the set \n");
	}	
}

function showUserData(userID) {
	dump("Show user classification \n");
	if(!userID) {
	var tempLabel =document.getElementById("participant-list").selectedItem.getAttribute("label");
	} else {
		tempLabel = userID;
	}
	//dump("Got label " + tempLabel + " and " + resultData[tempLabel] + "\n");
	var htmlView = document.getElementById("html-user-view").contentDocument.body;
	var tempString = '';
	for(i in resultData[tempLabel]) {
		userResults = resultData[tempLabel][i].values;
		//dump("Looking at " + i + " for " + tempLabel + " with list" + userResults + "\n");
		tempString = tempString + "<h1>" + i + "</h1>";
		var arUserResults = userResults.split(",");
		dump(arUserResults.length + " in the cat \n");
		for(j=0; j<arUserResults.length;j++) {
			//dump("Mapping " + arUserResults[j] + "\n");
			tempString += "<a href=\"javascript:parent.showClassifications('" + arUserResults[j] +"','" + tempLabel +  "');\">" + arUserResults[j]  + "</a><br/>";
		}
	}
	//dump(tempString + "\n" + " is going to " + htmlView.nodeName + " with " + htmlView.innerHTML + "\n");
	htmlView.innerHTML = tempString;
	//dump("\n\ninnerhtml is " + htmlView.innerHTML + "\n");

}

function buildResultsGrid() {
	dump("\n\nBuilding results by item \n\n")
	for(tempLabel in resultData) {
		//dump("$$$ " + tempLabel + ".");
		//tempLabel = resultData[h]

		for(i in resultData[tempLabel]) {
			//dump("i is " + i + " with values " + resultData[tempLabel][i].values + ".");
			userResults = resultData[tempLabel][i].values;
			var arUserResults = userResults.split(",");
			//dump(arUserResults.length + " in the cat, ");
			for(j=0; j<arUserResults.length;j++) {
				if(!resultGrid[arUserResults[j]]) { 	
					resultGrid[arUserResults[j]] = new
 Object();
					}
				for(k=0; k<arUserResults.length;k++) {
			if( !resultGrid[arUserResults[j]][arUserResults[k]] ) {
					resultGrid[ arUserResults[j]][arUserResults[k] ] =1;

				} else {
					resultGrid[ arUserResults[j]][arUserResults[k]]++;
				}
			}
		}
	}
	}
	/* dump("\nResultGrid\n")
	for(i in resultGrid) {
		dump(i + "::")
		for( j in resultGrid[i]) dump(j + " with " + resultGrid[i][j] + ", ");
		dump("\n");
	} */
}

function showClassifications(catLabel,backTo) {
	var htmlView = document.getElementById("html-user-view").contentDocument.body;
	dump("\n\nShowing Classifications for " + catLabel + "\n\n");
	var resultSet = resultGrid[catLabel];
	for(var j in resultSet) dump("rs " + j + " ");
	tempString = '<h1>' + catLabel + ' Grouping Count</h1>';
	for(i in resultSet) {
		tempString += resultSet[i] + " " + i + "<br/>";
		
	}
	tempString += "<br/><br/><a href=\"javascript:parent.showUserData('" + backTo + "');\">back to user" + backTo + "</a>";
	dump("html is " + tempString + "\n");
	htmlView.innerHTML = tempString;
	
}

function populateMatrix() {
	numCats = structCount(resultGrid);
	var grid = document.getElementById("uzcardsort-matrix");
	//dump("got grid " + grid + "\n");
	var tempNode, tempColumn, tempRow, tempText, tempFirstRow;
	var expectedValue =0;
	tempNode = grid.childNodes.item(0);
	
	for(var i in resultGrid) {
		
		tempColumn = document.createElement("column");
		tempNode.appendChild(tempColumn);
	}
	var tempFirstRow = document.createElement("row");
	var colCount = 0;
	
	tempText = document.createElement("text");
	tempFirstRow.appendChild(tempText);
	for(var j in resultGrid) {
		colCount++;
		tempText = document.createElement("text");
		tempText.setAttribute("tooltiptext",j);
		tempText.setAttribute("value",colCount);
		tempFirstRow.appendChild(tempText);
		
	}
	
	//grid.childNodes.item(1).appendChild();
	grid.childNodes.item(1).replaceChild(tempFirstRow, grid.childNodes.item(1).childNodes.item(0));
	//tempNode = grid;
	var dummyReplaced = false;
	for(var y in resultGrid) {
		expectedValue = 0;
		//dump("\ny is " + y + ":");
		tempRow = document.createElement("row");
		
		tempText = document.createElement("text");
		tempText.setAttribute("value", y)
		tempRow.appendChild(tempText);
		for(var x in resultGrid) {
		
			//dump(x + ",");
			tempText = document.createElement("text");
			if(resultGrid[y][x] && y != x) {
				tempText.setAttribute("value", resultGrid[y][x]);
				//dump("adding " + parseInt(resultGrid[y][x]) + " to ev");
				expectedValue += parseInt(resultGrid[y][x]);
			}
			if(dummyReplaced) {
			tempRow.appendChild(tempText);
			} else {
			//grid.childNodes.item(1).replaceChild(tempRow, grid.childNodes.item(1).childNodes.item(0));
			grid.childNodes.item(1).appendChild(tempRow)
			dummyReplaced = true;
			}
		}
		//grid.appendChild(tempNode);
		grid.childNodes.item(1).appendChild(tempRow);
		resultCorrelations[y] = new Object();
		resultCorrelations[y].expectedValue = expectedValue / numCats;
		dump("\nExpected value logged as " + resultCorrelations[y].expectedValue + " with " + expectedValue + " out of " + numCats + " for " + x + "\n");
		
	}
	
}

function computeCorrelations() {
	// obs - mean ^ 2 / mean
	var effect = 0;
	var arOffset;
	var observed;
	var bestCorrelate = new Object();
	for(var i in resultGrid) {
		toBeCategorized[i] = 1;
		dump("correlating " + i + "\n");
		bestCorrelate.score = 0;
		if(resultCorrelations[i]) {
		
		resultCorrelations[i].effect = new Object();	
		resultCorrelations[i].array = new Array(1);
		arOffset = 0;
		for(var j in resultGrid[i]) {
			if(i != j) {
				if(resultGrid[i][j]) {
					observed = resultGrid[i][j];
				} else {
					resultGrid[i][j] = resultCorrelations[i].expectedValue;
				}
				//dump("computing effect with " + resultGrid[i] + " " +  resultGrid[i][j] + " " + resultCorrelations[i].expectedValue + "\n");
				effect =parseInt(resultGrid[i][j]) - parseInt(resultCorrelations[i].expectedValue) ;
				//dump("initial effect " + effect + "\n");
				effect = (effect * effect)/ resultCorrelations[i].expectedValue;
				//dump("final effect for " + i + " with " + j  + "\n" +  effect + "\n");
				resultCorrelations[i].effect[j] = effect;
				
				// GET THE BEST CORRELATE
				if(effect > bestCorrelate.score) {
				  bestCorrelate.score = effect;
				  bestCorrelate.value = j;
				}
				//orderedArrayInsert(resultCorrelations[i].array, effect, j)
			}
		}

		resultCorrelations[i].best = new Object();
		resultCorrelations[i].best.score = bestCorrelate.score;
		resultCorrelations[i].best.value = bestCorrelate.value;
		dump("best match is for " + i+  " is "  + resultCorrelations[i].best.value  + " at " + resultCorrelations[i].best.score + "\n\n");
	}
	}
	
}


function groupBestMatches() {
	var bestMatch = findBestFirstMatch();
    for(zz in toBeCategorized) {
		dump("------------" + structCount(toBeCategorized) + " " + i + " correlations left \n");
		dump("Looking at " + zz + "\n");
		if(zz && zz.length && resultCorrelations[zz] && resultCorrelations[i].effect) findBestMatch(zz,resultCorrelations[zz].effect);
	}
}
// Look for the best match of a target in the remaining pool
// and the existing groups
function findBestMatch(key, effects) {
	dump("---------Finding best match " + key + "\n");
	var bestMatchScore = 0;
	var bestMatchKey, bestMatchValue;
	var groupMatch;
	var groupLen;
	// Check matches with available singletonsm
	if(toBeCategorized[key]) {
	for(var i in effects) {
		// If the key pairing  is still available
		
		if(toBeCategorized[i]) {
		dump("considering " + i + " for indiv match with " + toBeCategorized[i] + "\n");
		//dump("considering " + effects[i] + " for " + i + " with " + key +  " and effect " + effects[i] + " >? " + bestMatchScore + "\n");
		if(effects[i] > bestMatchScore) {
			bestMatchScore = effects[i];
			bestMatchValue = i;
			bestMatchKey = key;
		}
	}
	}
	dumpKeys(toBeCategorized);
	dump("ANALYSIS-TEMP: best solo match for " + bestMatchKey + " is " + bestMatchValue + ",");
	dump("  Got " + groups.length + " groups to compare \n");
	groupLen = groups.length
	var foundGroup = false;
	for(var j=0;j<groupLen;j++) {
		//dump("Checking group match " + j + " of " + groupLen + " groups  with " + key + " " + " and " + effects[i] + "\n");
		if(toBeCategorized[key]) {
		
		groupMatch = computeMatchToGroup(key, groups[j]);
		//dump("------------Group match is " + groupMatch + "\n");
		if(groupMatch > bestMatchScore) {
			dump("\nGroup beat individual best, deleting " + key  + " \n");
			addToGroup(key, groups[j], groupMatch);
			delete toBeCategorized[key];
			foundGroup = true;
			dump("-----------Tobe done down to " + structCount(toBeCategorized) + "\n");

			
			/* if(bestMatchScore > 0) {
				makeNewGroup(bestMatchKey, bestMatchValue, bestMatchScore) }
			
			dump("-----------Tobe done down to " + structCount(toBeCategorized) + " after removing " + bestMatchKey + " " + bestMatchValue + "\n");
			*/
			}
		}
	}
	if(!foundGroup) {
		if(toBeCategorized[i]) {
		dump("ANALYSIS: making new group with " + bestMatchKey + " " + bestMatchValue + " \n");
			if(bestMatchScore > 0) {
			
			makeNewGroup(bestMatchKey, bestMatchValue, bestMatchScore) }
			// Other wise make a new group with the key and it's best match
			delete toBeCategorized[bestMatchKey];
			delete toBeCategorized[bestMatchValue];
			dump("-----------No grouup match done down to " + structCount(toBeCategorized) + " after removing " + bestMatchKey + " " + bestMatchValue + "\n");
		}
	}
	}
}


function dumpGroups() {
	for(var i=0;i<groups.length;i++) {
		dump("----GROUP " + i + " ----\n");
		for(var j=0;j<groups[i].matches.length;j++) {
			dump(groups[i].matches[j].keys + "\n");
		}
		dump("\n\n");
	}
}

function buildTree() {
	var displayPanel = document.getElementById("tree-frame").contentDocument.body;
	dump("Display is " + displayPanel + " " + displayPanel.innerHTML + "\n");
	var tempHTML = '';	
	var matchString; 
	var count = 0;
		for(var i=0;i<groups.length;i++) {
		tempHTML += "<h1>Group" + i + "</h1>";
		for(var j=0;j<groups[i].matches.length;j++) {
			
			count += groups[i].matches[j].keys.split("|").length + 1;
			tempHTML += groups[i].matches[j].keys.replace("|","<br/>");
			tempHTML += "<br/>";
			//dump(groups[i].matches[j].keys + "\n");
		}
		tempHTML += "<br/>"
	}
	tempHTML += "Total count: " + count + "\n";
	dump("Built tree with " + tempHTML + "\n");
	displayPanel.innerHTML = tempHTML;
}

function makeNewGroup(key, value, score) {

	offset = groups.length;
	dump("Creating group " + offset + " with " + key + " and " + value + " of score " + score + "\n");
	groups[offset] = new Object();
	groups[offset].matches = new Array();
	groups[offset].matches[0] = new Object();
	groups[offset].matches[0].keys = key + "|" + value;
	groups[offset].matches[0].score = score;
	//dumpGroups();
}

function addToGroup(key, group, score) {
	var offset = group.matches.length;
		dump("ANALYSIS: Addiing " + key + " to existing group (n=" + offset + ") with " + score + "\n");
	group.matches[offset] = new Object();
	group.matches[offset].keys = key;
	group.matches[offset].score = score;
	//dumpGroups();
}

function computeMatchToGroup(key, group) {
	//dump("matching to group " + key + " group \n");
	var groupKeys, groupMatchTotal, groupMatchAvg, tempString;
	if(group && group.matches && group.matches.length) {
	var matches = group.matches;
	//dump("Matches is " + group.length + "\n")
	for(var i=0;i<matches.length;i++) {
		groupMatchTotal = 0;
		//dump("A match is " + matches[i].keys + "\n");
		groupKeys = matches[i].keys.split("|");
		for(var j=0;j<groupKeys.length;j++) {
			//dump("INGROUP ");
			//dump("For " + key + " and " + groupKeys[j] + ":");
			if(resultCorrelations[key] && resultCorrelations[key].effect && resultCorrelations[key].effect[groupKeys[j]]) {
				//dump("added " + resultCorrelations[key].effect[groupKeys[j]] + " for " + key + " and " + groupKeys[j] + "\n");
				groupMatchTotal += resultCorrelations[key].effect[groupKeys[j]];
			} else {
				
				if(resultCorrelations[j] && resultCorrelations[groupKeys[j]].effect[key]) {
					groupMatchTotal += resultCorrelations[groupKeys[j]].effect[key];
					//dump("added " + resultCorrelations[groupKeys[j]].effect[key] + " for " + key + " and " + groupKeys[j] + "\n");
				} else {
					//dump("ERR: no effect found for group member\n");
				}
			}
			//dump("total " + groupMatchTotal + ".");
		}
		groupMatchAvg = groupMatchTotal / groupKeys.length;
		dump("\ncomputed group match of " + groupMatchAvg + " for group " + matches[i].keys + " to " + key + "\n");
		return(groupMatchAvg);
	}
	}
}

/* sequence 
populateMatrix();
computeCorrelations();
groupBestMatches();
	-> findBestFirstMatch

*/
function findBestFirstMatch() {
	var bestMatchScore = 0;
	var bestMatchKey, bestMatchValue;
	for(var i in resultCorrelations) {
		if(resultCorrelations[i].best.score > bestMatchScore) {
			bestMatchScore = resultCorrelations[i].best.score;
			bestMatchValue = resultCorrelations[i].best.value;
			bestMatchKey = i;
		}
	}
	dump("Found first best match " + bestMatchScore + " " + bestMatchValue + " " + bestMatchKey + "\n");
	var offset = groups.length
	groups[offset] = new Object;
	groups[offset].matches = new Array();
	groups[offset].matches[0] = new Object();
	groups[offset].matches[0].keys = bestMatchValue + "|" + bestMatchKey;
	groups[offset].matches[0].score = bestMatchScore;	
	//dump("tobecat had " + structCount(toBeCategorized))
	delete toBeCategorized[bestMatchValue];
	delete toBeCategorized[bestMatchKey];
	dump("after first best match " + structCount(toBeCategorized) + "\n");

}



function orderedArrayInsert(array, value, key) {
	var arLen = array.length;
	dump("arLen is " + arLen + "\n");
	if(arLen == 1) {
		array[0] = new Object;
		array[0].value = -1;
	}
	var insertPoint =0;
	var insertFound = false;
	for(var i=0;i<arLen;i++) {
		if(!insertFound && array[i].value < value) {
			insertFound = true;
			insertPoint = i;
			break;
		}
	}
	dump("inserting " + value + " for " + key + " at " + insertPoint);
	for(var j=arLen;j>insertPoint;j--) {
		if(j == arLen) array[j] = new Object();
		array[j].value  = array[j-1].value;
		array[j].key  = array[j-1].key;
		
	}
	dump("insert point is " + insertPoint + "\n");
	array[insertPoint].value = value;
	array[insertPoint].key = key;
	
}

function dumpKeys(struct) {
	for(var x in struct) dump(x + ".");
	dump("\n\n");
}


function saveMatrix() {
	output= '\t';
	
	for(var i in resultGrid) {
		output += "\t" + i;
	}
	output += "\n";
	var colCount = 0;
	for(var i in resultGrid) {
		colCount++;
		output += "\t" + colCount;
	}
	output += "\n";
	rowCount = 0;
	for(var y in resultGrid) {
		rowCount++;
		dump("\ny is " + y + ":");
		output += y + "\t" + rowCount + "\t";
		for(var x in resultGrid) {
			if(resultGrid[y][x]) {
				output+= resultGrid[y][x] + "\t";
			} else {
				output += 0 + "\t";
			}			
		}
		output += "\n";
	}

 var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   var fileType = "*";
     fp.init(window, "Select a CSS file", nsIFilePicker.modeSave);
   fp.appendFilters(nsIFilePicker.filterAll);

   try {
     var ret = fp.show();
     if (ret == nsIFilePicker.returnCancel)
       return null;
   }
   catch (ex) {
     dump("filePicker.chooseInputFile threw an exception\n");
     return null;
   }
	var dataFile = new File(fp.file.path);

	dump(dataFile.exists + " exists\n");
	dataFile.open("w",744);
	dump("opened \n");
	dataFile.write(output);
	dataFile.close();
	dump("done \n");

}

